unit UfrmMain;

{$DEFINE DEBUG}
{$UNDEF DEBUG}

{$IFNDEF DEBUG}
{$O+,D-,Q-,R-}
{$ENDIF DEBUG}

{ $Revision: 2 $ }
{  $Archive: /Delphi 2.0/Projekte/ApplicationWrapperDemo/UfrmMain.pas $ }
{ $Workfile: UfrmMain.pas $ }
{   $Author: Cueb $ }
{     $Date: 1.07.97 16:39 $ }
{  $Modtime: 1.07.97 16:15 $ }
{  $History: UfrmMain.pas $ }
{  }
{ *****************  Version 2  ***************** }
{ User: Cueb         Date: 1.07.97    Time: 16:39 }
{ Updated in $/Delphi 2.0/Projekte/ApplicationWrapperDemo }
{ Release 1.02 }
{  }
{ *****************  Version 1  ***************** }
{ User: Cueb         Date: 26.06.97   Time: 0:09 }
{ Created in $/Delphi 2.0/Projekte/ApplicationWrapperDemo }
{ Release 1.01 }
{ $NoKeywords: $ }

interface

uses
	{$IFDEF DEBUG}
	Debug, 
	{$ENDIF DEBUG}
	Windows,
	Classes,
	Graphics,
	Forms,
	Controls,
	Menus,
	Dialogs,
	StdCtrls,
	Buttons,
	ExtCtrls,
	ComCtrls,
	ApplicationWrapper,
	Messages, Grids;

type
	{BM class TfrmMain}
	TfrmMain = class(TForm)
		pnlToolbar: TPanel;
    pnlExit: TPanel;
    btnExit: TSpeedButton;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    ApplicationWrapper: TApplicationWrapper;
		procedure cmdExit(Sender: TObject);
		procedure DoHint(Sender: TObject);
		procedure ApplicationWrapperMessage(var Msg: TMsg;
			var Handled: Boolean);
		procedure ApplicationWrapperShowHint(var HintStr: string;
			var CanShow: Boolean; var HintInfo: THintInfo);
    procedure ApplicationWrapperHotkey(Sender: TObject);
    procedure ApplicationWrapperLoaded(Sender: TObject);
    procedure ApplicationWrapperActiveFormChange(Sender: TObject);
    procedure ApplicationWrapperActiveControlChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ApplicationWrapperProcessParams(Sender: TObject;
      ParamList: TStringList);
	private
		{BM Private declarations }
	public
		{BM Public declarations }
	end;

var
	frmMain: TfrmMain;

implementation

{$R VERSIONINFO.RES}
{$R *.DFM}

uses
	SysUtils;
	
{BM cmdExit}
procedure TfrmMain.cmdExit(Sender: TObject);
begin
	Application.MainForm.Close;
end;

{BM DoHint}
procedure TfrmMain.DoHint(Sender: TObject);
begin
	if StatusBar.SimplePanel then begin
		StatusBar.SimpleText	:= Application.Hint;
		end
	else begin
		if StatusBar.Panels.Count > 0 then begin
			StatusBar.Panels[0].Text	:= Application.Hint;
		end;
	end;
end;

{BM ApplicationWrapperMessage}
procedure TfrmMain.ApplicationWrapperMessage(var Msg: TMsg;
  var Handled: Boolean);
begin
	Handled					:= False;
	Panel1.Caption	:= TimeToStr(Now) + ' : ' + IntToStr(Msg.Message);
	Panel1.Hint			:= Panel1.Caption;
end;

{BM ApplicationWrapperShowHint}
procedure TfrmMain.ApplicationWrapperShowHint(var HintStr: string;
	var CanShow: Boolean; var HintInfo: THintInfo);
var
	cp	: TPoint;
begin
	if HintInfo.HintControl is TPanel then begin
		GetCursorPos(cp);
		inc(cp.X, 8);
		inc(cp.Y, 2);
		HintInfo.HintPos	:= cp;
		HintInfo.HintColor	:= $0080FF80;
		end
	else begin
		HintInfo.HintColor	:= $008000FF;
	end;
end;

{BM ApplicationWrapperHotkey}
procedure TfrmMain.ApplicationWrapperHotkey(Sender: TObject);
begin
	// Don't use Application.Restore if RunMinimized is True !
	// restore the application
	PostMessage(Application.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
end;

{BM ApplicationWrapperLoaded}  
procedure TfrmMain.ApplicationWrapperLoaded(Sender: TObject);
var
	msgText	: String;
begin
	// use this event for hotkey verifying
	if (ApplicationWrapper.Hotkey <> 0) then with ApplicationWrapper do begin
		// ShowMessage -> EAV !
		// Application.MessageBox -> makes main window wisible !
		case HotkeyResult of
			-1	:	begin
					// The function is unsuccessful - the hot key is invalid.
					msgText	:= 'Hotkey [' + ShortCutToText(Hotkey)+ '] is invalid!';
				end;
			0		:	begin
					// The function is unsuccessful - the window is invalid.
					msgText	:= 'window is invalid!';
				end;
			1		:	begin
					// The function is successful, and no other window has the same hot key.
					msgText	:= 'Hotkey [' + ShortCutToText(Hotkey)+ '] is valid!';
				end;
			2		:	begin
					// The function is successful, but another window already has the same hot key.
					msgText	:= 'another window already has the same hot Hotkey! [' + ShortCutToText(Hotkey)+ '] ';
				end;
		end;
		MessageBox(Self.Handle, PChar(msgText), 'Note', MB_OK);
	end;
end;

{BM ApplicationWrapperActiveFormChange}
procedure TfrmMain.ApplicationWrapperActiveFormChange(Sender: TObject);
begin
	Beep;
end;

{BM ApplicationWrapperActiveControlChange}
procedure TfrmMain.ApplicationWrapperActiveControlChange(Sender: TObject);
begin
	Beep;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	if ApplicationWrapper <> nil then begin
		pnlToolbar.Caption	:= 'ApplicationWrapper is still alive ...';
		end
	else begin
		pnlToolbar.Caption	:= 'ApplicationWrapper is dead!';
	end;
end;

{BM ApplicationWrapperProcessParams}
procedure TfrmMain.ApplicationWrapperProcessParams(Sender: TObject;
	ParamList: TStringList);
var
	i			: Integer;
begin
	// first parameter is always the full expanded path of the exe file.
	for i := 1 to ParamList.Count - 1 do begin
		ShowMessage('Param [' + IntToStr(i) + '] : ' + ParamList[i]);
	end;
end;

end.

